Subject: [Technical Errata Reported] RFC5884 (5085)

From: RFC Errata System <[email-masked]>
Date: Thu, 10 Aug 2017 22:35:50 -0700 (PDT)

The following errata report has been submitted for RFC5884,
"Bidirectional Forwarding Detection (BFD) for MPLS Label Switched Paths (LSPs)".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata/eid5085

--------------------------------------
Type: Technical
Reported by: Balaji Rajagopalan <[email-masked]>

Section: 6

Original Text
-------------
The egress LSR MAY respond with an LSP Ping Echo
reply message that carries the local discriminator assigned by it for
the BFD session.

Corrected Text
--------------
The egress LSR MUST respond with an LSP Ping Echo reply message that
MAY carry the local discriminator assigned by it for the BFD session.

Notes
-----
It is not clear from the original text which of the following is optional:
  -  The egress MUST send a reply, but the discriminator in the reply is optional
  -  The reply itself is optional
 
Technically, the reply cannot be optional, because the egress needs to report LSP-Ping verification status to the ingress.

The proposed text recommends to include BFD discriminator in the reply. This was the intent of the original text.

Instructions:
-------------
This erratum is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party  
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC5884 (draft-ietf-bfd-mpls-07)
--------------------------------------
Title               : Bidirectional Forwarding Detection (BFD) for MPLS Label Switched Paths (LSPs)
Publication Date    : June 2010
Author(s)           : R. Aggarwal, K. Kompella, T. Nadeau, G. Swallow
Category            : PROPOSED STANDARD
Source              : Bidirectional Forwarding Detection
Area                : Routing
Stream              : IETF
Verifying Party     : IESG

---

From: Jeffrey Haas <[email-masked]>
Date: Fri, 11 Aug 2017 13:39:31 -0400

[Note that I have adjusted the addresses in the headers to try to catch the
RFC authors' current accounts.]

The 5884 interop issue keeps bubbling up.  Balaji submitted an errata, which
provides us with a good place to start technical discussion.

Please note I also spent some time off-list discussing this errata with
Balaji.

> Original Text

My opinion follows:

In section 6 - 

:    On receipt of the LSP Ping Echo request message, the egress LSR MUST
:    send a BFD Control packet to the ingress LSR, if the validation of
:    the FEC in the LSP Ping Echo request message succeeds.  This BFD
:    Control packet MUST set the Your Discriminator field to the
:    discriminator received from the ingress LSR in the LSP Ping Echo
:    request message.  The egress LSR MAY respond with an LSP Ping Echo
:    reply message that carries the local discriminator assigned by it for
:    the BFD session.  The local discriminator assigned by the egress LSR
:    MUST be used as the My Discriminator field in the BFD session packets
:    sent by the egress LSR.

In the text above, I consider it quite clear that the receipt of the BFD
packet contains sufficient state to bring up the BFD session.  The receipt
of the same Discriminator in the LSP Ping Echo Reply is optional.

This makes sense partially because the reply may be dropped and we want the
BFD session to come up as fast as possible.

The point of contention appears to be what to do if we *never* get such
replies.  It's worth pointing out additional text in RFC 5884, section 3.2.

:    Hence, BFD is used in conjunction with LSP Ping for MPLS LSP fault
:    detection:
: 
:       i) LSP Ping is used for bootstrapping the BFD session as described
:          later in this document.
: 
:      ii) BFD is used to exchange fault detection (i.e., BFD session)
:          packets at the required detection interval.
: 
:     iii) LSP Ping is used to periodically verify the control plane
:          against the data plane by ensuring that the LSP is mapped to
:          the same FEC, at the egress, as the ingress.

iii above reminds us that the LSP may be torn down because LSP Ping fails.
Thus, it seems problematic that we do not get a reply ever.

However, with the BFD session in the Up state, we have information proving
that the LSP is up.  Thus we have contradictory intent.

---

My opinion is that the MAY in the RFC 5884 procedures is intended to have
the BFD session come up by the most expedient means.  I do not believe the
likely intent was to say "don't send Echo Reply".  Among other things, that
seems contrary to the intent of the general LSP Ping procedures.

Having given my personal observations, we now get to the business of the
Working Group: Debating intent and related text.  

-- Jeff

---

From: Greg Mirsky <[email-masked]>
Date: Fri, 11 Aug 2017 11:12:49 -0700

Re-sending to the corrected list (apologies for duplicates).

Dear All,
I suggest to reject this proposal. The current text is clear and the
mechanics of bootstrapping BFD session over MPLS LSP is well understood -
remote peer MUST start sending BFD control packets first and BFD peer MAY
send Echo Reply with its Local Discriminator as value in BFD Discriminator
TLV.

Regards,
Greg

On Fri, Aug 11, 2017 at 10:39 AM, Jeffrey Haas <[email-masked]> wrote:

> > Technically, the reply cannot be optional, because the egress needs to
> report LSP-Ping verification status to the ingress.
> >
> > The proposed text recommends to include BFD discriminator in the reply.
> This was the intent of the original text.
>
> My opinion follows:
>
> In section 6 -
>

---

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Sat, 12 Aug 2017 02:45:38 +0000

Jeff, WG,

I believe there is one additional consideration — please see inline.

On Aug 11, 2017, at 1:39 PM, Jeffrey Haas <[email-masked]<mailto:[email-masked]>> wrote:

Original Text
-------------

Corrected Text
--------------

Notes
-----

This is correct — but even more so, technically, it is not up to RFC 5884 to define when an LSP-Ping reply is optional or not.

That’s’ up to https://tools.ietf.org/html/rfc8029#section-4.4

Lacking a Reply Mode set to "Do not reply" (https://tools.ietf.org/html/rfc8029#page-12) the RFC 8029 procedures dictate a response be sent, independent of whether the RFC 5884 procedures use that information or not.

More below.

My opinion follows:

In section 6 -

Yes, especially because the first sentence says that the egress sending a BFD Control packet implies FEC validation passed. However, https://tools.ietf.org/html/rfc8029#section-4.4 does more than FEC validation.

---

My individual opinion is that, as written, RFC 5884 cannot mean any other thing that “ The egress LSR MUST respond with an LSP Ping Echo reply message that
MAY carry the local discriminator assigned by it for the BFD session”.

In other words, I support this errata.

This is because RFC 5884 did not update RFC 4379’s procedures. And thus a response is needed based on 8029 irregardless of whether 5884 uses it.

That said, it is debatable whether that LSP Ping response is useful or not. If it is not sent, it does not comply to 8029. But if the WG wants for it to be not send, a new spec is needed.

Thanks,

-- Jeff

—
Carlos Pignataro, [email-masked]<mailto:[email-masked]>

“Sometimes I use big words that I do not fully understand, to make myself sound more photosynthesis."

---

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Sat, 12 Aug 2017 02:53:47 +0000

Greg,

> On Aug 11, 2017, at 2:12 PM, Greg Mirsky <[email-masked]> wrote:
> 
> I suggest to reject this proposal. The current text is clear and the mechanics of bootstrapping BFD session over MPLS LSP is well understood - remote peer MUST start sending BFD control packets first and BFD peer MAY send Echo Reply with its Local Discriminator as value in BFD Discriminator TLV.
> 

This seems to repeat the text in 5884 without explaining why you feel a particular interpretation is the correct technical one.

The text you include:
	“MAY send Echo Reply with its Local Discriminator as value in BFD Discriminator TLV”

suffers from the ambiguity that this Errata is trying to clarify. Which one is it?
* (MAY send Echo Reply with its Local Disc)
* (MAY send Echo Reply), with its Local Disc.

The actual text is:
   The egress LSR MAY respond with an LSP Ping Echo
!  reply message that carries the local discriminator assigned by it for
   the BFD session. 

And NOT:
   The egress LSR MAY respond with an LSP Ping Echo
!  reply message, which carries the local discriminator assigned by it for
   the BFD session. 

Based on restrictive versus non-restrictive clause, I feel it is correct to accept the errata.

And by the way, RFC 5884 is not say what happens if the LSP Ping Reply has a different discriminator value!

Thanks,

Carlos.

> Working Group: Debating intent and related text.

—
Carlos Pignataro, [email-masked]

---

From: Greg Mirsky <[email-masked]>
Date: Mon, 14 Aug 2017 10:56:13 -0700

Hi Jeff, et al,
greatly appreciate the most detailed analysis that explains the reasoning
of the filed Errata. Please consider my in-lined and tagged with GIM>>
notes. And since in the center of this discussion is LSP Ping, I've added
MPLS WG.

Best regards,
Greg

> On Thu, Aug 10, 2017 at 10:35:50PM -0700, RFC Errata System wrote:
GIM>> I'll list quotes from RFC 4379 that, in my view, indicate that the
echo reply is optional:

   - "... and returned unchanged by the receiver in the echo reply (if any)"
   - "When an MPLS echo request is received, the receiver is expected to verify
   that the control plane and data plane are both healthy (for the FEC
   Stack being pinged) and that the two planes are in sync."
   - " An LSR X that receives an MPLS echo request then processes it as
    follows."

In my interpretation of these quotes, not only echo reply is optional
(first quote) but even action by the echo request receiver (second). And
the third, from section 4.4, that leads to '7. Send Reply Packet:' does not
use normative language and thus we can interpret the whole section 4.4 as
an example, recomendation to implementer.

> report LSP-Ping verification status to the ingress.
GIM>> The purpose of the LSP Ping with BFD Discriminator TLV is to
bootstrap BFD session, not to verify consistency of the control plane and
the  data plane. That is why, I believe, RFC 5884 explicitly mandates
egress LSR to send BFD control packet first, before optionally sending echo
reply.

> Thus, it seems problematic that we do not get a reply ever.
GIM>> I believe that the suggested periodic LSP Ping SHOULD NOT include BFD
Discriminator TLV and thus their processing would not follow the RFC 5884.
As for the bootstrapping Echo requests, if the BFD control packets from
egress LSR never arrive to the ingress, then the ingress will continue
periodically send LSP ping with BFD Discriminator TLV for pre-defined time.

> that the LSP is up.  Thus we have contradictory intent.
GIM>> I'd expect BFD session to go down if the LSP gets torn. If the data
plane remains in tact even though LSP expected to be removed, then the
suggested periodic verification of consistency between the control plane
and the data plane should help.

> seems contrary to the intent of the general LSP Ping procedures.

GIM>> RFC 5884 is clear in giving priority to BFD process not only by
stating "the egress LSR MUST send a BFD Control packet to the ingress LSR"
but by referring to this before mentioning Echo reply. And I agree with the
first part of your conclusion. But, as stated earlier in the thread, my
interpretation of the reference to Echo reply

"The egress LSR MAY respond with an LSP Ping Echo reply message that
carries the local discriminator assigned by it for  the BFD session"

is different. In my understanding, sending of Echo reply is optional but if
the egress LSR sends Echo reply, it MUST include BFD Discriminator TLV with
value set to the local discriminator. Which is redundant and unnecessary
for the ingress LSR.

---

From: Greg Mirsky <[email-masked]>
Date: Mon, 14 Aug 2017 11:11:55 -0700

Hi Carlos,
thank you for sharing your view on how LSP Echo request with BFD
Discriminator used to bootstrap a BFD session over MPLS LSP. I'm surprised
that you refer to RFC 8029 as normative reference when commenting on RFC
5884. But even if we look into RFC 8029, it still has the same texts I've
quoted in the previous note that suggest that echo reply is optional.
Consider one of them "The Sender's Handle is filled in by the sender and
returned unchanged by the receiver in the echo reply (if any)." Though
English is my third language, I interpret "if any" in that sentence as
clear indication that the echo reply may not be sent ever.

Regards,
Greg

On Fri, Aug 11, 2017 at 7:45 PM, Carlos Pignataro (cpignata) <
[email-masked]> wrote:

> On Aug 11, 2017, at 1:39 PM, Jeffrey Haas <[email-masked]> wrote:
>
> This is correct — but even more so, technically, it is not up to RFC 5884
> to define when an LSP-Ping reply is optional or not.
>
> Lacking a Reply Mode set to "Do not reply" (https://tools.ietf.org/html/
> rfc8029#page-12) the RFC 8029 procedures dictate a response be sent,
> independent of whether the RFC 5884 procedures use that information or not.
>
> More below.
>
>
> Yes, especially because the first sentence says that the egress sending a
> BFD Control packet implies FEC validation passed. However,
> https://tools.ietf.org/html/rfc8029#section-4.4 does more than FEC
> validation.
>
>
> My individual opinion is that, as written, RFC 5884 cannot mean any other
> thing that “ The egress LSR MUST respond with an LSP Ping Echo reply
> message that
> This is because RFC 5884 did not update RFC 4379’s procedures. And thus a
> response is needed based on 8029 irregardless of whether 5884 uses it.
>
> That said, it is debatable whether that LSP Ping response is useful or
> not. If it is not sent, it does not comply to 8029. But if the WG wants for
> it to be not send, a new spec is needed.
>
> Thanks,
>
> -- Jeff
>
>
> —
> *“Sometimes I use big words that I do not fully understand, to make myself
> sound more photosynthesis."*
>
>

---

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Tue, 15 Aug 2017 00:17:11 +0000

Greg,

This is my final email on this topic, since the arguments are now just silly and not technically constructive.

1. It's not about understanding English. It's about understanding specs! The "(if any)" that you quote means there are situations in which there's no echo reply. As I already explained to you, that's for example the case with Reply-mode: No-reply. However, the "(if any)" does not mean an Echo Reply is OPTIONAL. !! Or that you choose when a reply is not sent!!
2. RFC 8029 obsoleted 4379. But to my recollection, nothing changed relevant to this Errata.

BFD for MPLS could have updated LSP ping behavior -- it just didn't.

Sent from my iPad

On Aug 14, 2017, at 2:12 PM, Greg Mirsky <[email-masked]<mailto:[email-masked]>> wrote:

Hi Carlos,
thank you for sharing your view on how LSP Echo request with BFD Discriminator used to bootstrap a BFD session over MPLS LSP. I'm surprised that you refer to RFC 8029 as normative reference when commenting on RFC 5884. But even if we look into RFC 8029, it still has the same texts I've quoted in the previous note that suggest that echo reply is optional. Consider one of them "The Sender's Handle is filled in by the sender and returned unchanged by the receiver in the echo reply (if any)." Though English is my third language, I interpret "if any" in that sentence as clear indication that the echo reply may not be sent ever.

Regards,
Greg

On Fri, Aug 11, 2017 at 7:45 PM, Carlos Pignataro (cpignata) <[email-masked]<mailto:[email-masked]>> wrote:
Jeff, WG,

Original Text
-------------

Corrected Text
--------------

Notes
-----

More below.

My opinion follows:

In section 6 -

---

Thanks,

-- Jeff

—

---

From: Mach Chen <[email-masked]>
Date: Tue, 15 Aug 2017 07:56:17 +0000

Hi all,

IMHO, the point is not about whether the Echo Reply is optional for a normal LSP Ping, where the echo reply is totally controlled by the reply mode.

For RFC5884, since the reply mode is not specified, based on the current text, it can be interpreted as the following two ways:

1)      it implies a new "mode" introduced, it's actually a "special" LSP Ping,  the process is just as what is currently described in the RFC: an Echo Reply is OPTINAL, whether and when to send Echo Reply is up to the egress LSR, and the Ingress LSR should not assume an Echo reply will be returned;

2)      the echo reply is still controlled by the reply mode, and given that there is a "Do not reply" mode, the current text seems right, but not that clear.

I incline to think way (2) is more nature, if so,  the proposed "Corrected Text" may not work if the Sender set the reply mode to "Do not reply".

I'd suggest:

Original Text
-------------

NEW:
The egress LSR MAY respond with an LSP Ping Echo
reply message that carries the local discriminator assigned by it for
the BFD session. Whether to send an LSP Ping Echo reply message is
determined by the reply mode carried the received Echo request message.

Best regards,
Mach

From: Rtg-bfd [mailto:[email-masked]] On Behalf Of Carlos Pignataro (cpignata)
Sent: Tuesday, August 15, 2017 8:17 AM
To: Greg Mirsky <[email-masked]>
Cc: Tom Nadeau <[email-masked]>; [email-masked]; Kireeti Kompella ([email-masked]) <[email-masked]>; Alia Atlas <[email-masked]>; Reshad Rahman (rrahman) <[email-masked]>; rtg-bfd@ietf. org <[email-masked]>
Subject: Re: [Technical Errata Reported] RFC5884 (5085)

Greg,

Sent from my iPad

Regards,
Greg

I believe there is one additional consideration - please see inline.

Section: 6

Original Text
-------------

Corrected Text
--------------

Notes
-----

This is correct - but even more so, technically, it is not up to RFC 5884 to define when an LSP-Ping reply is optional or not.

That's' up to https://tools.ietf.org/html/rfc8029#section-4.4

More below.

My opinion follows:

In section 6 -

---

My individual opinion is that, as written, RFC 5884 cannot mean any other thing that " The egress LSR MUST respond with an LSP Ping Echo reply message that
MAY carry the local discriminator assigned by it for the BFD session".

This is because RFC 5884 did not update RFC 4379's procedures. And thus a response is needed based on 8029 irregardless of whether 5884 uses it.

Thanks,

-- Jeff

-

"Sometimes I use big words that I do not fully understand, to make myself sound more photosynthesis."

---

From: "Les Ginsberg (ginsberg)" <[email-masked]>
Date: Tue, 15 Aug 2017 12:16:39 +0000

I tend to agree with Mach - and I think what Mach states is also reinforcing the point that Carlos has made - which is that echo reply procedures are defined by RFC 8029 - not by RFC 5884.

However, the current text suffers from much more than the ambiguity regarding Echo Reply.

1)Second paragraph of Section 6 goes back and forth between discussing BFD Control packets, then Echo Reply, then BFD Control Packets

2)Third paragraph of Section 6 has an inappropriate use of "," in the sentence:

"The BFD Control packets from the
   ingress to the egress LSR MUST set the local discriminator of the
   egress LSR, in the Your Discriminator field."

3)Section 6.1 defines when the BFD Discriminator TLV MUST be sent and when it is optional in LSP ping. There is actually no need for Section 6 to say anything in this regard.

I propose revised text below - which is much more extensive in its changes than what has been proposed thus far, but I think it is necessary to eliminate all ambiguity.
That said, there is no question that the current text is subject to multiple interpretations - so any change in text runs the risk of introducing new interoperability issues. On balance it is probably necessary to take this risk as there is no guarantee that implementations are interoperable today, but the WG should still consider this point carefully.

The text below replaces current paragraphs 2 and 3 of Section 6.

<new text start>
On receipt of the LSP Ping Echo request message, the egress LSR MUST
   send a BFD Control packet to the ingress LSR, if the validation of
   the FEC in the LSP Ping Echo request message succeeds.  This BFD
   Control packet MUST set the Your Discriminator field to the
   discriminator received from the ingress LSR in the LSP Ping Echo
   request message.    The local discriminator assigned by the egress LSR
   MUST be used as the My Discriminator field in the BFD session packets
   sent by the egress LSR.

   The ingress LSR follows the procedures in [BFD] to send BFD Control
   packets to the egress LSR in response to the BFD Control packets
   received from the egress LSR.  The BFD Control packets from the
   ingress to the egress LSR MUST set the local discriminator of the
   egress LSR in the Your Discriminator field.  The egress LSR
   demultiplexes the BFD session based on the received Your
   Discriminator field.  As mentioned above, the egress LSR MUST send
   Control packets to the ingress LSR with the Your Discriminator field
   set to the local discriminator of the ingress LSR.  The ingress LSR
   uses this to demultiplex the BFD session.

  The egress LSR follows the procedures defined in [RFC 8029] to determine when to respond with an LSP Ping Echo  reply message.
<new text end>

    Les

From: Rtg-bfd [mailto:[email-masked]] On Behalf Of Mach Chen
Sent: Tuesday, August 15, 2017 12:56 AM
To: Carlos Pignataro (cpignata); Greg Mirsky
Cc: Tom Nadeau; [email-masked]; Kireeti Kompella ([email-masked]); Alia Atlas; Reshad Rahman (rrahman); rtg-bfd@ietf. org
Subject: RE: [Technical Errata Reported] RFC5884 (5085)

Hi all,

I'd suggest:

Original Text
-------------

NEW:

Best regards,
Mach

From: Rtg-bfd [mailto:[email-masked]] On Behalf Of Carlos Pignataro (cpignata)
Sent: Tuesday, August 15, 2017 8:17 AM
To: Greg Mirsky <[email-masked]<mailto:[email-masked]>>
Cc: Tom Nadeau <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>; Kireeti Kompella ([email-masked]<mailto:[email-masked]>) <[email-masked]<mailto:[email-masked]>>; Alia Atlas <[email-masked]<mailto:[email-masked]>>; Reshad Rahman (rrahman) <[email-masked]<mailto:[email-masked]>>; rtg-bfd@ietf. org <[email-masked]<mailto:[email-masked]>>
Subject: Re: [Technical Errata Reported] RFC5884 (5085)

Greg,

Sent from my iPad

Regards,
Greg

Original Text
-------------

Corrected Text
--------------

Notes
-----

More below.

My opinion follows:

In section 6 -

---

Thanks,

-- Jeff

-

---

From: Kireeti Kompella <[email-masked]>
Date: Tue, 15 Aug 2017 15:20:28 +0000

As a co-author, I can say that the intent was that the LSP ping reply be sent, but the BFD discriminator be optional.  Not sending an LSP ping reply could lead to the LSP being torn down.

The basic idea here is to use LSP ping to bootstrap a bfd session.  But the semantics of LSP ping don't change; not sending a reply indicates that the LSP is down. 

Kireeti

> On Aug 11, 2017, at 10:39, Jeffrey Haas <[email-masked]> wrote:
>

---

From: Thomas Nadeau <[email-masked]>
Date: Tue, 15 Aug 2017 11:22:01 -0400

> On Aug 15, 2017:11:20 AM, at 11:20 AM, Kireeti Kompella <[email-masked]> wrote:
> 

	That is exactly my recollection of how we designed (and implemented) this too.

	—Tom

---

From: Greg Mirsky <[email-masked]>
Date: Tue, 15 Aug 2017 09:56:30 -0700

Hi Mach and Les,
thank you for your proposals.I think that the text provided by Les gives
very clear and detailed explanation. I have one suggestion to clarify
whether egress LSR MUST include BFD Discriminator TLV with local value in
the Echo reply. My understanding of the RFC 584 is that BFD Discriminator
TLV MUST be included in Echo reply.

Regards,
Greg

On Tue, Aug 15, 2017 at 5:16 AM, Les Ginsberg (ginsberg) <[email-masked]
> wrote:

> I tend to agree with Mach – and I think what Mach states is also
> reinforcing the point that Carlos has made – which is that echo reply
> procedures are defined by RFC 8029 – not by RFC 5884.
>
>
>
> 1)Second paragraph of Section 6 goes back and forth between discussing BFD
> Control packets, then Echo Reply, then BFD Control Packets
>
>
>
> 2)Third paragraph of Section 6 has an inappropriate use of “,” in the
> sentence:
>
>
>
> “The BFD Control packets from the
>
>    egress *LSR, in *the Your Discriminator field.”
>
>
>
> 3)Section 6.1 defines when the BFD Discriminator TLV MUST be sent and when
> it is optional in LSP ping. There is actually no need for Section 6 to say
> anything in this regard.
>
>
>
> I propose revised text below – which is much more extensive in its changes
> than what has been proposed thus far, but I think it is necessary to
> eliminate all ambiguity.
>
> That said, there is no question that the current text is subject to
> multiple interpretations – so any change in text runs the risk of
> introducing new interoperability issues. On balance it is probably
> necessary to take this risk as there is no guarantee that implementations
> are interoperable today, but the WG should still consider this point
> carefully.
>
>
>
> *<new text start>*
> *On receipt of the LSP Ping Echo request message, the egress LSR MUST*
>
> *   send a BFD Control packet to the ingress LSR, if the validation of*
>
> *   the FEC in the LSP Ping Echo request message succeeds.  This BFD*
>
> *   Control packet MUST set the Your Discriminator field to the*
>
> *   discriminator received from the ingress LSR in the LSP Ping Echo*
>
> *   request message.    The local discriminator assigned by the egress LSR*
>
> *   MUST be used as the My Discriminator field in the BFD session packets*
>
> *   sent by the egress LSR.*
>
>
>
> *   The ingress LSR follows the procedures in [BFD] to send BFD Control*
>
> *   packets to the egress LSR in response to the BFD Control packets*
>
> *   received from the egress LSR.  The BFD Control packets from the*
>
> *   ingress to the egress LSR MUST set the local discriminator of the*
>
> *   egress LSR in the Your Discriminator field.  The egress LSR*
>
> *   demultiplexes the BFD session based on the received Your*
>
> *   Discriminator field.  As mentioned above, the egress LSR MUST send*
>
> *   Control packets to the ingress LSR with the Your Discriminator field*
>
> *   set to the local discriminator of the ingress LSR.  The ingress LSR*
>
> *   uses this to demultiplex the BFD session.*
>
>
>
> *  The egress LSR follows the procedures defined in [RFC 8029] to
> determine when to respond with an LSP Ping Echo  reply message.*
>
> *<new text end>*
>
>
>
>     Les
>
>
>
>
>
> *From:* Rtg-bfd [mailto:[email-masked]] *On Behalf Of *Mach Chen
> *Sent:* Tuesday, August 15, 2017 12:56 AM
> *To:* Carlos Pignataro (cpignata); Greg Mirsky
> *Cc:* Tom Nadeau; [email-masked]; Kireeti Kompella ([email-masked]);
> Alia Atlas; Reshad Rahman (rrahman); rtg-bfd@ietf. org
> *Subject:* RE: [Technical Errata Reported] RFC5884 (5085)
>
>
>
> Hi all,
>
>
>
> IMHO, the point is not about whether the Echo Reply is optional for a
> normal LSP Ping, where the echo reply is totally controlled by the reply
> mode.
>
>
>
> For RFC5884, since the reply mode is not specified, based on the current
> text, it can be interpreted as the following two ways:
>
> 1)      it implies a new “mode” introduced, it’s actually a “special” LSP
> Ping,  the process is just as what is currently described in the RFC: an
> Echo Reply is OPTINAL, whether and when to send Echo Reply is up to the
> egress LSR, and the Ingress LSR should not assume an Echo reply will be
> returned;
>
> 2)      the echo reply is still controlled by the reply mode, and given
> that there is a “Do not reply” mode, the current text seems right, but not
> that clear.
>
>
>
> I incline to think way (2) is more nature, if so,  the proposed “Corrected
> Text” may not work if the Sender set the reply mode to “Do not reply”.
>
>
>
> I’d suggest:
>
>
>
> Original Text
> -------------
> *From:* Rtg-bfd [mailto:[email-masked]
> <[email-masked]>] *On Behalf Of *Carlos Pignataro (cpignata)
> *Sent:* Tuesday, August 15, 2017 8:17 AM
> *To:* Greg Mirsky <[email-masked]>
> *Cc:* Tom Nadeau <[email-masked]>; [email-masked]; Kireeti
> Kompella ([email-masked]) <[email-masked]>; Alia Atlas <
> [email-masked]>; Reshad Rahman (rrahman) <[email-masked]>;
> rtg-bfd@ietf. org <[email-masked]>
> *Subject:* Re: [Technical Errata Reported] RFC5884 (5085)
>
>
>
> Greg,
>
>
>
> 1. It's not about understanding English. It's about understanding specs!
> The "(if any)" that you quote means there are situations in which there's
> no echo reply. As I already explained to you, that's for example the case
> with Reply-mode: No-reply. However, the "(if any)" does not mean an Echo
> Reply is OPTIONAL. !! Or that you choose when a reply is not sent!!
>
> On Aug 14, 2017, at 2:12 PM, Greg Mirsky <[email-masked]> wrote:
>
> Hi Carlos,
>

---

From: Balaji Rajagopalan <[email-masked]>
Date: Wed, 16 Aug 2017 05:23:16 +0000

I’m aware of three different behaviours from three different vendors that I came across in the course of inter-op:

-         Always respond to an LSP-Ping request carrying a BFD disc

-         Never send a response to an LSP-Ping request carrying a BFD disc

-         Don’t respond to the first LSP-Ping request carrying a BFD disc, but respond to the subsequent ones

This experience leads me to believe that this procedure is NOT well-understood.  So, publication of errata on this issue is necessary.

As some of the co-authors have clarified in further emails, inclusion of BFD discriminator in the LSP-Ping request does not change LSP-Ping’s basic function. So, the egress must send a reply. This is what the erratum clarifies.

--
Balaji Rajagopalan

From: Rtg-bfd <[email-masked]> on behalf of Greg Mirsky <[email-masked]>
Date: Friday, 11 August 2017 at 11:42 PM
To: Jeffrey Haas <[email-masked]>
Cc: Kireeti Kompella <[email-masked]>, Thomas Nadeau <[email-masked]>, "[email-masked]" <[email-masked]>, "Reshad Rahman (rrahman)" <[email-masked]>, Alia Atlas <[email-masked]>
Subject: Re: [Technical Errata Reported] RFC5884 (5085)

Dear All,

Regards,
Greg

On Fri, Aug 11, 2017 at 10:39 AM, Jeffrey Haas <[email-masked]<mailto:[email-masked]>> wrote:
[Note that I have adjusted the addresses in the headers to try to catch the
RFC authors' current accounts.]

My opinion follows:

In section 6 -

---

-- Jeff

---

From: "Carlos Pignataro (cpignata)" <[email-masked]>
Date: Wed, 16 Aug 2017 14:20:08 +0000

This sounds like a good summary of the tactical fix.

(Although, like Les wrote down, saying “MUST follow [LSP-Ping]” is better than “MUST Send a Reply”)

As an aside -- When it comes to Interop, I remember also issues around the UDP Port on the egress BFD Control packet, depending on whether the response is IP-based vs. over an MPLS LSP.  Tracking this down, this was identified at https://www.ietf.org/mail-archive/web/rtg-bfd/current/msg00447.html (comments on Sections 6 and 7), and it seems, we may have the right bug but a wrong fix.

Thanks,

-- Carlos.

From: Rtg-bfd <[email-masked]> on behalf of Balaji Rajagopalan <[email-masked]>
Date: Wednesday, August 16, 2017 at 1:23 AM
To: Greg Mirsky <[email-masked]>, Jeff Haas <[email-masked]>
Cc: Kireeti Kompella <[email-masked]>, Tom Nadeau <[email-masked]>, "[email-masked]" <[email-masked]>, "Reshad Rahman (rrahman)" <[email-masked]>, Alia Atlas <[email-masked]>
Subject: Re: [Technical Errata Reported] RFC5884 (5085)

  *   Always respond to an LSP-Ping request carrying a BFD disc
  *   Never send a response to an LSP-Ping request carrying a BFD disc
  *   Don’t respond to the first LSP-Ping request carrying a BFD disc, but respond to the subsequent ones

--
Balaji Rajagopalan

Dear All,

Regards,
Greg

My opinion follows:

In section 6 -

---

-- Jeff

---

From: Greg Mirsky <[email-masked]>
Date: Wed, 16 Aug 2017 07:57:11 -0700

Hi Balaji,
thank you for sharing your experience with the issue. Had you captured what
are the values of the Return Mode field in Echo request packets in each
case? Perhaps these would explain the behavior of the egress LSR.

Regards,
Greg

On Tue, Aug 15, 2017 at 10:23 PM, Balaji Rajagopalan <[email-masked]>
wrote:

> This experience leads me to believe that this procedure is NOT
> well-understood.  So, publication of errata on this issue is necessary.
>
>
>
> As some of the co-authors have clarified in further emails, inclusion of
> BFD discriminator in the LSP-Ping request does not change LSP-Ping’s basic
> function. So, the egress must send a reply. This is what the erratum
> clarifies.
>
>
>
> --
>
> Balaji Rajagopalan
>
>
>
>
>
>
>
> *From: *Rtg-bfd <[email-masked]> on behalf of Greg Mirsky <
> [email-masked]>
> *Date: *Friday, 11 August 2017 at 11:42 PM
> *To: *Jeffrey Haas <[email-masked]>
> *Cc: *Kireeti Kompella <[email-masked]>, Thomas Nadeau <
> [email-masked]>, "[email-masked]" <[email-masked]>, "Reshad
> Rahman (rrahman)" <[email-masked]>, Alia Atlas <[email-masked]>
> *Subject: *Re: [Technical Errata Reported] RFC5884 (5085)
>
>
>

---

From: "Les Ginsberg (ginsberg)" <[email-masked]>
Date: Tue, 15 Aug 2017 23:36:33 +0000

Greg –

Thanx.

Section 6.1 currently states:

“If the BFD session is not in UP state, the periodic LSP Ping Echo
   request messages MUST include the BFD Discriminator TLV.”

I think this language is unambiguous.
??

   Les

From: Greg Mirsky [mailto:[email-masked]]
Sent: Tuesday, August 15, 2017 9:56 AM
To: Les Ginsberg (ginsberg)
Cc: Mach Chen; Carlos Pignataro (cpignata); Tom Nadeau; [email-masked]; Kireeti Kompella ([email-masked]); Alia Atlas; Reshad Rahman (rrahman); rtg-bfd@ietf. org
Subject: Re: [Technical Errata Reported] RFC5884 (5085)

Hi Mach and Les,
thank you for your proposals.I think that the text provided by Les gives very clear and detailed explanation. I have one suggestion to clarify whether egress LSR MUST include BFD Discriminator TLV with local value in the Echo reply. My understanding of the RFC 584 is that BFD Discriminator TLV MUST be included in Echo reply.

Regards,
Greg

On Tue, Aug 15, 2017 at 5:16 AM, Les Ginsberg (ginsberg) <[email-masked]<mailto:[email-masked]>> wrote:
I tend to agree with Mach – and I think what Mach states is also reinforcing the point that Carlos has made – which is that echo reply procedures are defined by RFC 8029 – not by RFC 5884.

2)Third paragraph of Section 6 has an inappropriate use of “,” in the sentence:

“The BFD Control packets from the
   ingress to the egress LSR MUST set the local discriminator of the
   egress LSR, in the Your Discriminator field.”

I propose revised text below – which is much more extensive in its changes than what has been proposed thus far, but I think it is necessary to eliminate all ambiguity.
That said, there is no question that the current text is subject to multiple interpretations – so any change in text runs the risk of introducing new interoperability issues. On balance it is probably necessary to take this risk as there is no guarantee that implementations are interoperable today, but the WG should still consider this point carefully.

<new text start>

    Les

From: Rtg-bfd [mailto:[email-masked]<mailto:[email-masked]>] On Behalf Of Mach Chen
Sent: Tuesday, August 15, 2017 12:56 AM
To: Carlos Pignataro (cpignata); Greg Mirsky
Cc: Tom Nadeau; [email-masked]<mailto:[email-masked]>; Kireeti Kompella ([email-masked]<mailto:[email-masked]>); Alia Atlas; Reshad Rahman (rrahman); rtg-bfd@ietf. org
Subject: RE: [Technical Errata Reported] RFC5884 (5085)

Hi all,

1)      it implies a new “mode” introduced, it’s actually a “special” LSP Ping,  the process is just as what is currently described in the RFC: an Echo Reply is OPTINAL, whether and when to send Echo Reply is up to the egress LSR, and the Ingress LSR should not assume an Echo reply will be returned;

2)      the echo reply is still controlled by the reply mode, and given that there is a “Do not reply” mode, the current text seems right, but not that clear.

I incline to think way (2) is more nature, if so,  the proposed “Corrected Text” may not work if the Sender set the reply mode to “Do not reply”.

I’d suggest:

Original Text
-------------

NEW:

Best regards,
Mach

Greg,

Sent from my iPad

Regards,
Greg

Original Text
-------------

Corrected Text
--------------

Notes
-----

More below.

My opinion follows:

In section 6 -

---

Thanks,

-- Jeff

—

---

From: Greg Mirsky <[email-masked]>
Date: Tue, 15 Aug 2017 16:53:02 -0700

Hi Les,
apologies as I wasn't clear in my proposal. I've referred to the Echo reply
sent by the egress LSR. I think that the reference to RFC 8029 in the last
sentence is not sufficient to define use of BFD Discriminator TLV in Echo
reply. I think that Mach has captured it in the new text he provided that
may be used in place of the last sentence in your proposal as the following:

Your Text
The egress LSR follows the procedures defined in [RFC 8029] to determine
when to respond with an LSP Ping Echo  reply message.

Mach Text

determined by the value of the Reply Mode field carried in the received
Echo request message.

Kind regards,

Greg

On Tue, Aug 15, 2017 at 4:36 PM, Les Ginsberg (ginsberg) <[email-masked]

> *From:* Greg Mirsky [mailto:[email-masked]]
> *Sent:* Tuesday, August 15, 2017 9:56 AM
> *To:* Les Ginsberg (ginsberg)
> *Cc:* Mach Chen; Carlos Pignataro (cpignata); Tom Nadeau; [email-masked];
> Kireeti Kompella ([email-masked]); Alia Atlas; Reshad Rahman
> (rrahman); rtg-bfd@ietf. org
>
> On Tue, Aug 15, 2017 at 5:16 AM, Les Ginsberg (ginsberg) <
> [email-masked]> wrote:
>

---

From: Balaji Rajagopalan <[email-masked]>
Date: Tue, 22 Aug 2017 09:09:20 +0000

Hi Greg,

In all the three cases, the return mode field in the Echo request packet was set to 2 (Reply via an IPv4/IPv6 UDP packet).

--
Balaji Rajagopalan

From: Greg Mirsky <[email-masked]>
Date: Wednesday, 16 August 2017 at 8:27 PM
To: Balaji Rajagopalan <[email-masked]>
Cc: Jeffrey Haas <[email-masked]>, Kireeti Kompella <[email-masked]>, Thomas Nadeau <[email-masked]>, "[email-masked]" <[email-masked]>, "Reshad Rahman (rrahman)" <[email-masked]>, Alia Atlas <[email-masked]>
Subject: Re: [Technical Errata Reported] RFC5884 (5085)

Hi Balaji,
thank you for sharing your experience with the issue. Had you captured what are the values of the Return Mode field in Echo request packets in each case? Perhaps these would explain the behavior of the egress LSR.

Regards,
Greg

On Tue, Aug 15, 2017 at 10:23 PM, Balaji Rajagopalan <[email-masked]<mailto:[email-masked]>> wrote:
I’m aware of three different behaviours from three different vendors that I came across in the course of inter-op:

--
Balaji Rajagopalan

From: Rtg-bfd <[email-masked]<mailto:[email-masked]>> on behalf of Greg Mirsky <[email-masked]<mailto:[email-masked]>>
Date: Friday, 11 August 2017 at 11:42 PM
To: Jeffrey Haas <[email-masked]<mailto:[email-masked]>>
Cc: Kireeti Kompella <[email-masked]<mailto:[email-masked]>>, Thomas Nadeau <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "Reshad Rahman (rrahman)" <[email-masked]<mailto:[email-masked]>>, Alia Atlas <[email-masked]<mailto:[email-masked]>>
Subject: Re: [Technical Errata Reported] RFC5884 (5085)

Dear All,

Regards,
Greg

My opinion follows:

In section 6 -

---

-- Jeff

---

From: Balaji Rajagopalan <[email-masked]>
Date: Tue, 22 Aug 2017 09:16:37 +0000

That sounds better. How about the following text?

The egress LSR MUST follow the procedures described in [RFC4379] in processing the LSP Ping request. The LSP Ping reply generated by the egress MAY carry the local discriminator assigned by it for the BFD session.

--
Balaji Rajagopalan

From: Mach Chen <[email-masked]>
Date: Thursday, 17 August 2017 at 8:45 AM
To: "Carlos Pignataro (cpignata)" <[email-masked]>, Balaji Rajagopalan <[email-masked]>, Greg Mirsky <[email-masked]>, Jeffrey Haas <[email-masked]>
Cc: Kireeti Kompella <[email-masked]>, Thomas Nadeau <[email-masked]>, "[email-masked]" <[email-masked]>, "Reshad Rahman (rrahman)" <[email-masked]>, Alia Atlas <[email-masked]>
Subject: RE: [Technical Errata Reported] RFC5884 (5085)

Indeed, I also like Les’s suggestion!

Best regards,
Mach

From: Rtg-bfd [mailto:[email-masked]] On Behalf Of Carlos Pignataro (cpignata)
Sent: Wednesday, August 16, 2017 10:20 PM
To: Balaji Rajagopalan <[email-masked]>; Greg Mirsky <[email-masked]>; Jeffrey Haas <[email-masked]>
Cc: Kireeti Kompella <[email-masked]>; Thomas Nadeau <[email-masked]>; [email-masked]; Reshad Rahman (rrahman) <[email-masked]>; Alia Atlas <[email-masked]>
Subject: Re: [Technical Errata Reported] RFC5884 (5085)

Thanks,

-- Carlos.

From: Rtg-bfd <[email-masked]<mailto:[email-masked]>> on behalf of Balaji Rajagopalan <[email-masked]<mailto:[email-masked]>>
Date: Wednesday, August 16, 2017 at 1:23 AM
To: Greg Mirsky <[email-masked]<mailto:[email-masked]>>, Jeff Haas <[email-masked]<mailto:[email-masked]>>
Cc: Kireeti Kompella <[email-masked]<mailto:[email-masked]>>, Tom Nadeau <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "Reshad Rahman (rrahman)" <[email-masked]<mailto:[email-masked]>>, Alia Atlas <[email-masked]<mailto:[email-masked]>>
Subject: Re: [Technical Errata Reported] RFC5884 (5085)

--
Balaji Rajagopalan

Dear All,

Regards,
Greg

My opinion follows:

In section 6 -

---

-- Jeff

---

From: Greg Mirsky <[email-masked]>
Date: Tue, 22 Aug 2017 19:21:12 -0700

Hi Balaji,
I've been thinking about the value of including BFD Discriminator TLV in
echo reply sent by egress. What we'd expect ingress to do upon receiving
the reply? Match to bfd.remoteDiscr? I think that then echo reply must
include the value from the original BFD Discriminator TLV so that ingress
uses it to demux BFD sessions. Or ingress doesn't validate the value in BFD
Discriminator TLV but only that the TLV is included in reply? If we leave
actions of the ingress upon receipt of the reply with BFD Discriminator
underspecified it may result in another set of interoperability issues.
Perhaps the simplest way to avoid that would be to not allow BFD
Discriminator TLV in the reply.

Regards,
Greg

On Tue, Aug 22, 2017 at 2:16 AM, Balaji Rajagopalan <[email-masked]>
wrote:

> The egress LSR MUST follow the procedures described in [RFC4379] in
> processing the LSP Ping request. The LSP Ping reply generated by the egress
> *From: *Mach Chen <[email-masked]>
> *Date: *Thursday, 17 August 2017 at 8:45 AM
> *To: *"Carlos Pignataro (cpignata)" <[email-masked]>, Balaji
> Rajagopalan <[email-masked]>, Greg Mirsky <[email-masked]>,
> Jeffrey Haas <[email-masked]>
> *Subject: *RE: [Technical Errata Reported] RFC5884 (5085)
>
>
>
> *From:* Rtg-bfd [mailto:[email-masked]] *On Behalf Of *Carlos
> Pignataro (cpignata)
> *Sent:* Wednesday, August 16, 2017 10:20 PM
> *To:* Balaji Rajagopalan <[email-masked]>; Greg Mirsky <
> [email-masked]>; Jeffrey Haas <[email-masked]>
> *Cc:* Kireeti Kompella <[email-masked]>; Thomas Nadeau <
> [email-masked]>; [email-masked]; Reshad Rahman (rrahman) <
> [email-masked]>; Alia Atlas <[email-masked]>
> As an aside -- When it comes to Interop, I remember also issues around the
> UDP Port on the egress BFD Control packet, depending on whether the
> response is IP-based vs. over an MPLS LSP.  Tracking this down, this was
> identified at https://www.ietf.org/mail-archive/web/rtg-bfd/current/
> msg00447.html (comments on Sections 6 and 7), and it seems, we may have
> the right bug but a wrong fix.
>
>
>
> Thanks,
>
>
>
> -- Carlos.
>
>
>
> *From: *Rtg-bfd <[email-masked]> on behalf of Balaji
> Rajagopalan <[email-masked]>
> *Date: *Wednesday, August 16, 2017 at 1:23 AM
> *To: *Greg Mirsky <[email-masked]>, Jeff Haas <[email-masked]>
> *Cc: *Kireeti Kompella <[email-masked]>, Tom Nadeau <